## checker-framework-java 3.0.1+ds2

=== docs/examples/Makefile ===
JAVAC ?= $(realpath ../../checker/bin/javac)
MAVEN_EXAMPLE=MavenExampleJDK11
ifeq ($(shell java -version 2>&1 | grep version | grep 1.8 > /dev/null; printf $$?), 0)
MAVEN_EXAMPLE=MavenExample
endif

.PHONY: all

all: compile

compile:
	$(JAVAC) *.java
	cd fenum-extension && $(MAKE)
	cd subtyping-extension && $(MAKE)
	cd units-extension && $(MAKE)
	cd ${MAVEN_EXAMPLE} && $(MAKE)
	cd lombok && $(MAKE)

# TODO: type check the different files with the right checker;
#   some tests expect errors, compare against expected errors.

=== docs/manual/Makefile ===
# Put user-specific changes in your own Makefile.user.
# Make will silently continue if that file does not exist.
-include Makefile.user

# To regenerate this list, run:   latex-process-inputs -makefilelist manual.tex
TEX_FILES = \
manual.tex \
manual-style.tex \
introduction.tex \
nullness-checker.tex \
map-key-checker.tex \
optional-checker.tex \
interning-checker.tex \
lock-checker.tex \
index-checker.tex \
fenum-checker.tex \
tainting-checker.tex \
regex-checker.tex \
formatter-checker.tex \
i18n-format-checker.tex \
propkey-checker.tex \
signature-checker.tex \
guieffect-checker.tex \
units-checker.tex \
signedness-checker.tex \
constant-value-checker.tex \
aliasing-checker.tex \
reflection-checker.tex \
reflection-inference-rules.tex \
subtyping-checker.tex \
external-checkers.tex \
typestate-checker.tex \
generics.tex \
advanced-features.tex \
warnings.tex \
inference.tex \
annotating-libraries.tex \
creating-a-checker.tex \
external-tools.tex \
faq.tex \
troubleshooting.tex

all: manual.pdf manual.html

.PHONY: figures-all
figures-all:
	${MAKE} -C figures all

manual.pdf: bib-update figures-all check-labels
	latexmk -silent -pdf -interaction=nonstopmode manual.tex || latexmk -gg -pdf -interaction=nonstopmode manual.tex

html: manual.html
manual.html: manual.pdf CFLogo.png favicon-checkerframework.png ../api
	hevea -fix -exec xxdate.exe manual.tex
# I'm not sure why this is necessary; "hevea -fix" should run it automatically.
# Also, you need ImageMagick 6.8.0-2 Beta or later to avoid a bug.
	imagen manual
	./add-favicon-to-manual
# The following three lines are only necessary when using Hevea before version 2.04.
# With version 2.04 they have no effect but do no harm.
	\mv -f manual.html manual.html-with-htoc
	./hevea-retarget-crossrefs < manual.html-with-htoc > manual.html
	\rm -f manual.html-with-htoc
# Add CSS styling, since \newstyle doesn't work for me.
	sed -i -e "s%<style type=\"text/css\">%<style type=\"text/css\">\nimg { max-width: 100\%; max-height: 100\%; }%" manual.html
# Add CSS styling for some links, since \ahrefloc doesn't permit styling
	sed -i -e 's%\(<a href="#[^"]*"\)\(><span style="font-size:small">&\#X1F517;</span></a>\)%\1 style="color:inherit; text-decoration:none"\2%g' manual.html

.PHONY: contributors.tex
# The `git-authors` script is in https://github.com/plume-lib/plume-scripts
contributors.tex:
	git-authors --latex --punctuation > contributors.tex

../api:
	cd ../.. && ./gradlew allJavadoc

CFLogo.png: ../logo/Logo/CFLogo.png
	cp -p $< $@

favicon-checkerframework.png: ../logo/Checkmark/CFCheckmark_favicon.png
	cp -p $< $@

# Don't use \section; use \sectionAndLabel instead
.PHONY: check-labels
check-labels:
	if ( grep -n '^\\\(chapter\|\(sub\)*section\|paragraph\){' *.tex ) ; then false ; else true ; fi

export BIBINPUTS = $BIBINPUTS:.:bib
bib:
	git clone https://github.com/mernst/plume-bib.git bib
.PHONY: bib-update
bib-update: bib
# Even if this command fails, it does not terminate the make job.
# However, to skip it, invoke make as:  make NOGIT=1 ...
ifndef NOGIT
	-(cd bib && git pull && make)
endif

# Leaves manual.html, and .svg files that it references.
clean:
	@\rm -f *.aux *.blg *.dvi *.haux *.htoc *.idx *.ilg *.ind *.log *.out *.pdf *.ps *.toc manual.image.tex

very_clean: clean
	@\rm -f manual.html CFLogo.png

.PHONY: checklink
checklink:
	checklink-via-http

.PHONY: checklink-via-file
checklink-via-file:
	${CHECKLINK}/checklink -q -e `grep -v '^#' ${CHECKLINK}/checklink-args.txt` manual.html

# Example invocation:
#   CHECKLINK=$HOME/bin/src/checklink make checklink-via-http
.PHONY: checklink-via-http
checklink-via-http: manual.html
	rm -rf ${HOME}/public_html/tmp-cf-manual
	(cd .. && cp -prf manual ${HOME}/public_html/tmp-cf-manual)
	${CHECKLINK}/checklink -q -e `grep -v '^#' ${CHECKLINK}/checklink-args.txt` https://homes.cs.washington.edu/~mernst/tmp-cf-manual/manual.html

.PHONY: tags
tags: TAGS
TAGS: ${TEX_FILES}
	etags ${TEX_FILES}

=== checker/tests/nullness-extra/Makefile ===
# Tests that are currently passing
PASSING_TESTS = Bug109 compat issue265 issue594 issue607 multiple-errors package-anno shorthand
ifeq (,$(findstring 1.8,$(shell javac -version)))
  # issue309 and issue502 fail with Java 11 because of differences between Java 8 and Java 11 bytecode.
  # TODO: issue559 should work with an annotated jdk11.
  PASSING_TESTS_JDK8 = issue309 issue502 issue559
else
  PASSING_TESTS_JDK8 =
endif

# Tests that are currently not passing
FAILING_TESTS =

# Tests that are currently passing
all: ${PASSING_TESTS} ${PASSING_TESTS_JDK8}

# Tests that are currently not passing
skipped: ${FAILING_TESTS}


Bug109:
	$(JAVAC) -processor org.checkerframework.checker.nullness.NullnessChecker Bug109_A.java Bug109_B.java
	$(JAVAC) -processor org.checkerframework.checker.nullness.NullnessChecker Bug109_B.java Bug109_A.java


compat:
	$(MAKE) -C compat

issue265:
	$(MAKE) -C issue265

issue309:
	$(MAKE) -C issue309

issue502:
	$(MAKE) -C issue502

issue559:
	$(MAKE) -C issue559

issue594:
	$(MAKE) -C issue594

multiple-errors:
	$(MAKE) -C multiple-errors

package-anno:
	$(MAKE) -C package-anno

shorthand:
	$(MAKE) -C shorthand

issue607:
	$(MAKE) -C issue607

# All tests: passing and failing
.PHONY: all skipped ${PASSING_TESTS}

=== docs/examples/MavenExample/Makefile ===
.PHONY: all

all: clean
	mvn -fn compile > Out.txt 2>&1
	grep -qF "MavenExample.java:[25,29] error: [assignment.type.incompatible] incompatible types in assignment." Out.txt

clean:
	mvn -q clean
	rm -f Out.txt

=== docs/examples/MavenExampleJDK11/Makefile ===
.PHONY: all

all: clean
	mvn -fn compile > Out.txt 2>&1
	grep -qF "MavenExample.java:[29,29] error: [assignment.type.incompatible] incompatible types in assignment." Out.txt

clean:
	mvn -q clean
	rm -f Out.txt

=== docs/examples/fenum-extension/Makefile ===
FILES=qual/MyFenum.java

JAVAOPTS=

JAVAC?=../../../checker/bin/javac

# gets the full path to the directory of the make file, which is also the root dir of the qual folder
# for custom projects, it is best to encode the full root path as a variable
PROJECTDIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))

all: compile-for-test named-quals-test qual-folder-test clean

demo:
	$(JAVAC) $(JAVAOPTS) $(FILES)
	@echo "***** This command is expected to produce 21 errors:"
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.checker.fenum.FenumChecker -AqualDirs=$(PROJECTDIR) Demo.java

# compile qualifiers
compile-for-test:
	$(JAVAC) $(JAVAOPTS) $(FILES)

# test case for using externally defined qualifiers by explicitly naming them using the -Aquals option
named-quals-test:
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.checker.fenum.FenumChecker -Aquals=qual.MyFenum Demo.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt
	rm -f Out.txt

# test case for using externally defined qualifiers by loading them from a directory using the -AqualDirs option
qual-folder-test:
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.checker.fenum.FenumChecker -AqualDirs=$(PROJECTDIR) Demo.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt
	rm -f Out.txt

# test clean up
clean:
	rm -f qual/*.class

=== docs/examples/lombok/Makefile ===
.PHONY: all

# Delomboking seems to mess up line numbers. The actual error is on line 13, but the error appears on line 12.
# So check for both the error message and make sure it is for the right assignment.
all: clean
	- ../../../gradlew build > Out.txt 2>&1
	grep -qF "User.java:9: error: [argument.type.incompatible] incompatible types in argument." Out.txt && \
		grep -qF "Foo.java:12: error: [assignment.type.incompatible] incompatible types in assignment." Out.txt && \
		grep -qF "y = null; // error" Out.txt

clean:
	../../../gradlew clean
	rm -f Out.txt

=== docs/examples/subtyping-extension/Makefile ===
FILES=qual/Encrypted.java \
  qual/PossiblyUnencrypted.java

JAVAOPTS=

JAVAC?=../../../checker/bin/javac

# gets the full path to the directory of the make file, which is also the root dir of the qual folder
# for custom projects, it is best to encode the full root path as a variable
PROJECTDIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))

all: compile-for-test named-quals-test qual-folder-test clean

demo:
	$(JAVAC) $(JAVAOPTS) $(FILES)
	@echo "***** This command is expected to produce a warning on line 12 and an error on line 35:"
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.common.subtyping.SubtypingChecker -AqualDirs=$(PROJECTDIR) Demo.java

# compile qualifiers
compile-for-test:
	$(JAVAC) $(JAVAOPTS) $(FILES)

# test case for using externally defined qualifiers by explicitly naming them using the -Aquals option
named-quals-test:
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.common.subtyping.SubtypingChecker -Aquals=qual.Encrypted,qual.PossiblyUnencrypted Demo.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt
	rm -f Out.txt

# test case for using externally defined qualifiers by loading them from a directory using the -AqualDirs option
qual-folder-test:
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.common.subtyping.SubtypingChecker -AqualDirs=$(PROJECTDIR) Demo.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt
	rm -f Out.txt

# test clean up
clean:
	rm -f qual/*.class

=== docs/examples/units-extension/Makefile ===
FILES=qual/Frequency.java \
  qual/FrequencyRelations.java \
  qual/Hz.java \
  qual/kHz.java

JAVAOPTS= -classpath .:../../../checker/dist/checker.jar

JAVAC?=../../../checker/bin/javac

# gets the full path to the directory of the make file, which is also the root dir of the qual folder
# for custom projects, it is best to encode the full root path as a variable
PROJECTDIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))

all: compile-for-test named-quals-test qual-folder-test clean

demo:
	$(JAVAC) $(JAVAOPTS) $(FILES)
	@echo "***** This command is expected to produce errors on line 15 & 66:"
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.checker.units.UnitsChecker -AunitsDirs=$(PROJECTDIR) Demo.java

# compile qualifiers
compile-for-test:
	$(JAVAC) $(JAVAOPTS) $(FILES)

# test case for using externally defined units by explicitly naming them using the -Aunits option
named-quals-test:
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.checker.units.UnitsChecker -Aunits=qual.Hz,qual.kHz,qual.Frequency Demo.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt
	rm -f Out.txt

# test case for using externally defined units by loading them from a directory using the -AunitsDirs option
qual-folder-test:
	$(JAVAC) -classpath $(PROJECTDIR) -processor org.checkerframework.checker.units.UnitsChecker -AunitsDirs=$(PROJECTDIR) Demo.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt
	rm -f Out.txt

# test clean up
clean:
	rm -f qual/*.class

=== docs/manual/figures/Makefile ===
# Put user-specific changes in your own Makefile.user.
# Make will silently continue if that file does not exist.
-include Makefile.user

PDFFILES = $(patsubst %.svg,%.pdf,$(wildcard *.svg))

RSVG_CONVERT_VERSION := $(shell rsvg-convert --version 2>/dev/null)

all: ${PDFFILES} clean-obsolete-files svg-copy

svg-copy:
	cp -pf *.svg ..

%.pdf : %.svg
ifdef RSVG_CONVERT_VERSION
	rsvg-convert -f pdf -o $@ $<
else
	convert $< $@
endif

clean: clean-obsolete-files
	@\rm -f ${PDFFILES}

clean-obsolete-files:
	@\rm -f *.png
	@\rm -f *.eps

=== framework/tests/annotationclassloader/Makefile ===
# This makefile contains the commands to test the AnnotationClassLoader.
# Tt uses the aliasing checker as it is one of the framework checkers that has a
# qual directory with qualifiers that must be loaded using the loader.

# Gets the full path to the directory of the make file, which is also the root
# directory of the qual folder.
# For custom projects, it is best to encode the full root path as a variable.
PROJECTDIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))

# Use the Checker Framework javac.
# TODO: the dependency on the checker project isn't nice.
JAVAC = $(PROJECTDIR)/../../../checker/bin/javac

FRAMEWORKJAR := $(PROJECTDIR)/../../dist/framework.jar

STUBPARSERJAR := $(PROJECTDIR)/../../../../stubparser/javaparser-core/target/stubparser.jar

CHECKERQUALJAR := $(PROJECTDIR)/../../../checker/dist/checker-qual.jar

# build directories
DATAFLOWBUILD := $(PROJECTDIR)/../../../dataflow/build/classes/java/main
JAVACUTILBUILD := $(PROJECTDIR)/../../../javacutil/build/classes/java/main
FRAMEWORKBUILD := $(PROJECTDIR)/../../build/classes/java/main:$(PROJECTDIR)/../../build/resources/main/
CHECKERQUALBUILD := $(PROJECTDIR)/../../../checker-qual/build/classes/java/main


all: load-from-dir-test load-from-jar-test

# ======================================================
# demo or manual test usage:
# loads from build directories
demo1:
	@echo "***** This command is expected to produce an error on line 7:"
	$(JAVAC) \
	  -processorpath $(DATAFLOWBUILD):$(JAVACUTILBUILD):$(FRAMEWORKBUILD):${STUBPARSERJAR} \
	  -classpath $(PROJECTDIR):${CHECKERQUALBUILD} \
	  -processor org.checkerframework.common.aliasing.AliasingChecker \
	  -Anomsgtext \
	  -Anocheckjdk \
	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
	  LoaderTest.java

# loads from framework.jar
demo2:
	@echo "***** This command is expected to produce an error on line 7:"
	$(JAVAC) \
	  -processorpath $(FRAMEWORKJAR) \
	  -classpath $(PROJECTDIR):${CHECKERQUALJAR} \
	  -processor org.checkerframework.common.aliasing.AliasingChecker \
	  -Anomsgtext \
	  -Anocheckjdk \
	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
	  LoaderTest.java

# ======================================================
# gradle test usage:
# loads from build directories
load-from-dir-test:
	$(JAVAC) \
	  -processorpath $(DATAFLOWBUILD):$(JAVACUTILBUILD):$(FRAMEWORKBUILD):${STUBPARSERJAR} \
	  -classpath $(PROJECTDIR):${CHECKERQUALBUILD} \
	  -processor org.checkerframework.common.aliasing.AliasingChecker \
	  -Anomsgtext \
	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
	  -Anocheckjdk \
	  LoaderTest.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt -I 'Note'
	rm -f Out.txt

# loads from framework.jar
load-from-jar-test:
	$(JAVAC) \
	  -processorpath $(FRAMEWORKJAR) \
	  -classpath $(PROJECTDIR):${CHECKERQUALJAR} \
	  -processor org.checkerframework.common.aliasing.AliasingChecker \
	  -Anomsgtext \
	  -Anocheckjdk \
	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
	  LoaderTest.java > Out.txt 2>&1 || true
	diff -u Expected.txt Out.txt
	rm -f Out.txt

=== checker/tests/command-line/issue618/Makefile ===
.PHONY: all

all:
	$(JAVAC) -processor regex,org.checkerframework.checker.tainting.TaintingChecker TwoCheckers.java > out.txt 2>&1 || true
	diff -u expected.txt out.txt

=== debian/changelog ===
checker-framework-java (3.0.1+ds2-3) unstable; urgency=medium

  * Update standards to 4.5.1 (no changes)
  * Declare Multi-Arch: foreign

 -- Olek Wojnar <olek@debian.org>  Fri, 22 Jan 2021 13:33:33 -0500

checker-framework-java (3.0.1+ds2-2) unstable; urgency=high

  * Temporarily eliminate build of Android artifact
    - Will re-introduce once Kotlin allows build of Android dependencies

 -- Olek Wojnar <olek@debian.org>  Mon, 02 Nov 2020 14:45:01 -0500

checker-framework-java (3.0.1+ds2-1) unstable; urgency=medium

  * Remove additional problematic source file

 -- Olek Wojnar <olek@debian.org>  Sun, 25 Oct 2020 21:05:33 -0400

checker-framework-java (3.0.1+ds1-1) unstable; urgency=medium

  * Correct additional licensing concerns identified by FTP Team

 -- Olek Wojnar <olek@debian.org>  Thu, 22 Oct 2020 14:17:16 -0400

checker-framework-java (3.0.1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #959832)
  * Provide additional information about authors
  * Restore Gradle build system
  * Backport license clarifications from upstream in d/copyright
    - https://github.com/typetools/checker-framework/issues/3429

 -- Olek Wojnar <olek@debian.org>  Wed, 15 Jul 2020 16:06:07 -0400

=== debian/control ===
Source: checker-framework-java
Section: java
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Olek Wojnar <olek@debian.org>,
           Andreas Tille <tille@debian.org>,
Build-Depends: bnd,
               debhelper-compat (= 13),
               default-jdk,
               gradle-apt-plugin,
               gradle-debian-helper,
               libgradle-core-java,
               libgradle-plugins-java,
               maven-repo-helper,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/typetools/checker-framework
Vcs-Browser: https://salsa.debian.org/java-team/checker-framework-java
Vcs-Git: https://salsa.debian.org/java-team/checker-framework-java.git

Package: libchecker-framework-java
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Framework that makes Java’s type system more powerful and useful
 A "checker" is a tool that warns you about certain errors or gives you a
 guarantee that those errors do not occur. The Checker Framework comes with
 checkers for 24 specific types of errors.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Ensure packages build with no Internet access
export http_proxy=127.0.0.1:9
export https_proxy=127.0.0.1:9

%:
	dh $@ --buildsystem=gradle --with maven_repo_helper

override_dh_auto_test:

=== debian/watch ===
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="repack, repacksuffix=+ds, dversionmangle=s/\+ds\d*$//" \
   https://github.com/typetools/checker-framework/releases?after=checker-framework-3.7.0 \
   .*/checker-framework-(\d[\d.]*)\.tar\.gz debian uupdate

## checker-framework-java 3.2.0%2Bds

=== docs/examples/MavenExample/Makefile ===
.PHONY: all

all: clean
	mvn -B -fn compile > Out.txt 2>&1
	grep -qF "MavenExample.java:[25,29] error: [assignment.type.incompatible] incompatible types in assignment." Out.txt || (cat Out.txt && false)

clean:
	mvn -q clean
	rm -f Out.txt

## checker-framework-java 3.2.0+ds

=== docs/manual/Makefile ===
--- 
+++ 
@@ -46,12 +46,12 @@
 figures-all:
 	${MAKE} -C figures all
 
-manual.pdf: bib-update figures-all check-labels
+manual.pdf: ${TEX_FILES} bib-update figures-all check-labels
 	latexmk -silent -pdf -interaction=nonstopmode manual.tex || latexmk -gg -pdf -interaction=nonstopmode manual.tex
 
 html: manual.html
 manual.html: manual.pdf CFLogo.png favicon-checkerframework.png ../api
-	hevea -fix -exec xxdate.exe manual.tex
+	hevea -fix svg.hva -exec xxdate.exe manual.tex
 # I'm not sure why this is necessary; "hevea -fix" should run it automatically.
 # Also, you need ImageMagick 6.8.0-2 Beta or later to avoid a bug.
 	imagen manual

=== docs/examples/MavenExampleJDK11/Makefile ===
.PHONY: all

all: clean
	mvn -B -fn compile > Out.txt 2>&1
	grep -qF "MavenExample.java:[29,29] error: [assignment.type.incompatible] incompatible types in assignment." Out.txt || (cat Out.txt && false)

clean:
	mvn -q clean
	rm -f Out.txt

=== docs/examples/lombok/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 	- ../../../gradlew build > Out.txt 2>&1
 	grep -qF "User.java:9: error: [argument.type.incompatible] incompatible types in argument." Out.txt && \
 		grep -qF "Foo.java:12: error: [assignment.type.incompatible] incompatible types in assignment." Out.txt && \
-		grep -qF "y = null; // error" Out.txt
+		grep -qF "y = null; // error" Out.txt || (cat Out.txt && false)
 
 clean:
 	../../../gradlew clean

=== framework/tests/annotationclassloader/Makefile ===
--- 
+++ 
@@ -36,7 +36,7 @@
 	  -classpath $(PROJECTDIR):${CHECKERQUALBUILD} \
 	  -processor org.checkerframework.common.aliasing.AliasingChecker \
 	  -Anomsgtext \
-	  -Anocheckjdk \
+	  -ApermitMissingJdk \
 	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
 	  LoaderTest.java
 
@@ -48,7 +48,7 @@
 	  -classpath $(PROJECTDIR):${CHECKERQUALJAR} \
 	  -processor org.checkerframework.common.aliasing.AliasingChecker \
 	  -Anomsgtext \
-	  -Anocheckjdk \
+	  -ApermitMissingJdk \
 	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
 	  LoaderTest.java
 
@@ -62,7 +62,7 @@
 	  -processor org.checkerframework.common.aliasing.AliasingChecker \
 	  -Anomsgtext \
 	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
-	  -Anocheckjdk \
+	  -ApermitMissingJdk \
 	  LoaderTest.java > Out.txt 2>&1 || true
 	diff -u Expected.txt Out.txt -I 'Note'
 	rm -f Out.txt
@@ -74,7 +74,7 @@
 	  -classpath $(PROJECTDIR):${CHECKERQUALJAR} \
 	  -processor org.checkerframework.common.aliasing.AliasingChecker \
 	  -Anomsgtext \
-	  -Anocheckjdk \
+	  -ApermitMissingJdk \
 	  -Astubs=$(PROJECTDIR)/../aliasing/stubfile.astub \
 	  LoaderTest.java > Out.txt 2>&1 || true
 	diff -u Expected.txt Out.txt

=== checker/tests/nullness-extra/issue265/Makefile ===
.PHONY: all

all:
	mkdir -p bin
	$(JAVAC) -processor org.checkerframework.checker.nullness.NullnessChecker *.java -d bin/
	$(JAVAC) -processor org.checkerframework.checker.nullness.NullnessChecker Delta.java -cp bin/ -d bin/
	rm bin/*.class
	rmdir bin

=== checker/tests/nullness-extra/issue309/Makefile ===
.PHONY: all

all:
	rm -f Out.txt
	mkdir -p bin
	$(JAVAC) lib/*.java -d bin/
	jar cvf lib.jar -C bin/ lib/Lib.class
	$(JAVAC) -processor org.checkerframework.checker.nullness.NullnessChecker -Anomsgtext Issue309.java -d bin/ -cp lib.jar > Out.txt 2>&1
	diff -u Expected.txt Out.txt
# Run again with stub file. (This used to cause a crash.)
	$(JAVAC) -processor org.checkerframework.checker.nullness.NullnessChecker -Anomsgtext Issue309.java -d bin/ -cp lib.jar -Astubs=Lib.astub > Out.txt 2>&1
	diff -u Expected.txt Out.txt
	rm Out.txt lib.jar bin/*.class bin/lib/*.class
	rmdir bin/lib bin/

=== debian/changelog ===
checker-framework-java (3.2.0+ds-3) unstable; urgency=medium

  * Team upload
  [ Pushkar Kulkarni ]
  * Fix javac-21 compiler warnings (Closes: #1052474)

  [ tony mancill ]
  * Fix FTBFS twice in a row (Closes: #1043754)

 -- tony mancill <tmancill@debian.org>  Wed, 08 Nov 2023 21:12:11 -0800

checker-framework-java (3.2.0+ds-2) unstable; urgency=medium

  * Build dataflow and javacutil modules
    - New build-dependency on libplume-util-java
    - Added deprecated-getexpression.patch due to older Java code
  * Reenable building of checker-qual-android module

 -- Olek Wojnar <olek@debian.org>  Fri, 14 Apr 2023 16:13:02 -0400

checker-framework-java (3.2.0+ds-1) unstable; urgency=medium

  * New upstream release (Closes: #1021632)
    - Refresh patches
  * Refresh packaging
    - Update d/watch
    - Update standards to 4.6.2 (no changes)
    - Disable Salsa BLHC due to incorrect non-verbose build error

 -- Olek Wojnar <olek@debian.org>  Tue, 03 Jan 2023 10:09:25 -0500

checker-framework-java (3.0.1+ds2-4) unstable; urgency=medium

  * Fix watch file
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Submit.
  * Update standards version to 4.6.1, no changes needed.
  * Add debian/salsa-ci.yml
  * Homepage is not in the list of fields for upstream metadata

 -- Andreas Tille <tille@debian.org>  Wed, 30 Nov 2022 19:32:17 +0100

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,20 @@
 Section: java
 Priority: optional
 Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
-Uploaders: Olek Wojnar <olek@debian.org>,
-           Andreas Tille <tille@debian.org>,
-Build-Depends: bnd,
-               debhelper-compat (= 13),
-               default-jdk,
-               gradle-apt-plugin,
-               gradle-debian-helper,
-               libgradle-core-java,
-               libgradle-plugins-java,
-               maven-repo-helper,
-Standards-Version: 4.5.1
+Uploaders:
+ Olek Wojnar <olek@debian.org>,
+ Andreas Tille <tille@debian.org>,
+Build-Depends:
+ bnd,
+ debhelper-compat (= 13),
+ default-jdk,
+ gradle-apt-plugin,
+ gradle-debian-helper,
+ libgradle-core-java,
+ libgradle-plugins-java,
+ libplume-util-java,
+ maven-repo-helper,
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/typetools/checker-framework
 Vcs-Browser: https://salsa.debian.org/java-team/checker-framework-java

=== debian/rules ===
--- 
+++ 
@@ -10,4 +10,8 @@
 %:
 	dh $@ --buildsystem=gradle --with maven_repo_helper
 
+override_dh_auto_clean:
+	rm -rf checker-qual/src checker-qual-android/src
+	dh_auto_clean
+
 override_dh_auto_test:

=== debian/watch ===
version=4

opts="repack, repacksuffix=+ds, dversionmangle=auto" \
 https://github.com/typetools/checker-framework/tags?after=checker-framework-3.7.1 \
 .*/checker-framework-(\d[\d.]*)\.tar\.gz
